Index: LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2839)
@@ -856,6 +1029,12 @@
                     zfice(i) = zfice(i)**exposant_glace_old
               endif
+        if (fl_cor_ebil .GT. 0) then
+              zt(i) = zt(i) + (1.-zfice(i))*zcond(i) & 
+           &             * RLVTT/RCPD/(1.0+RVTMP2*(zq(i)+zmqc(i)+zcond(i))) &
+                      +zfice(i)*zcond(i) * RLSTT/RCPD/(1.0+RVTMP2*(zq(i)+zmqc(i)+zcond(i)))
+        else 
               zt(i) = zt(i) + (1.-zfice(i))*zcond(i) * RLVTT/RCPD/(1.0+RVTMP2*(zq(i)+zcond(i))) &
-                       +zfice(i)*zcond(i) * RLSTT/RCPD/(1.0+RVTMP2*(zq(i)+zcond(i)))
+                      +zfice(i)*zcond(i) * RLSTT/RCPD/(1.0+RVTMP2*(zq(i)+zcond(i)))
+        end if
            ENDDO
          endif
@@ -863,4 +1042,5 @@
        ENDIF
 !>AJ
+
      ! ----------------------------------------------------------------
      ! P3> Formation des precipitations
@@ -958,4 +1138,8 @@
      !         zoliqp = MAX(zoliq(i)*(1.-zfice(i))-1.*zpluie   , 0.0)
      !         zoliqi = MAX(zoliq(i)*zfice(i)-1.*zice   , 0.0)
+!JLD : les 2 variables zoliqp et zoliqi crorresponent a des pseudo precip
+!      temporaires et ne doivent pas etre calcule (alors qu'elles le sont
+!      si iflag_bergeron <> 2
+!      A SUPPRIMER A TERME
               zoliqp(i) = MAX(zoliq(i)*(1.-zfice(i))-1.*zpluie  , 0.0)
               zoliqi(i) = MAX(zoliq(i)*zfice(i)-1.*zice  , 0.0)
@@ -966,4 +1150,5 @@
         ENDDO  ! i = 1,klon
      ENDDO     ! n = 1,ninter
+
      ! ----------------------------------------------------------------
      !
@@ -994,4 +1179,26 @@
              zqpreci(i)=(zcond(i)-zoliq(i))*zfice(i)
              zqprecl(i)=(zcond(i)-zoliq(i))*(1.-zfice(i))
+           if (fl_cor_ebil .GT. 0) then
+             zcp=RCPD*(1.0+RVTMP2*(zq(i)+zmqc(i)+zcond(i)))
+             coef1 = rneb(i,k)*RLSTT/zcp*zdqsdT_raw(i)
+!            Calcul de DT si toute les precips liquides congelent
+             DeltaT = RLMLT*zqprecl(i) / (zcp*(1.+coef1))
+!            On ne veut pas que T devienne superieur a la temp. de congelation.
+!            donc que Delta > RTT-zt(i
+             DeltaT = max( min( RTT-zt(i), DeltaT) , 0. )
+             zt(i)      = zt(i)      + DeltaT
+!            Eau vaporisee du fait de l'augmentation de T
+             Deltaq = rneb(i,k)*zdqsdT_raw(i)*DeltaT
+!            on reajoute cette eau vaporise a la vapeur et on l'enleve des precips
+             zq(i) = zq(i) +  Deltaq
+!            Les 3 max si dessous prtotegent uniquement des erreurs d'arrondies
+             zcond(i)   = max( zcond(i)- Deltaq, 0. )
+!            precip liquide qui congele ou qui s'evapore
+             Deltaqprecl = -zcp/RLMLT*(1.+coef1)*DeltaT
+             zqprecl(i) = max( zqprecl(i) + Deltaqprecl, 0. )
+!            bilan eau glacee
+             zqpreci(i) = max (zqpreci(i) - Deltaqprecl - Deltaq, 0.)
+           else ! if (fl_cor_ebil .GT. 0)
+!            ancien calcul
              zcp=RCPD*(1.0+RVTMP2*(zq(i)+zcond(i)))
              coef1 = RLMLT*zdqs(i)/RLVTT
@@ -1002,4 +1209,5 @@
              zq(i)      = zq(i)      + zcp/RLVTT*zdqs(i)*DeltaT
              zt(i)      = zt(i)      + DeltaT
+           end if ! if (fl_cor_ebil .GT. 0)
            ENDIF  ! rneb(i,k) .GT. 0.0
          ENDDO
@@ -1021,11 +1229,12 @@
          IF (rneb(i,k).GT.0.0) THEN
 !CR on prend en compte la phase glace
-           if (.not.ice_thermo) then
-           d_ql(i,k) = zoliq(i)
-           d_qi(i,k) = 0.
-           else
+!JLD inutile car on ne passe jamais ici si .not.ice_thermo
+!           if (.not.ice_thermo) then
+!           d_ql(i,k) = zoliq(i)
+!           d_qi(i,k) = 0.
+!           else
            d_ql(i,k) = (1-zfice(i))*zoliq(i)
            d_qi(i,k) = zfice(i)*zoliq(i)
-           endif
+!           endif
 !AJ<
            zrfl(i) = zrfl(i)+ MAX(zcond(i)*(1.-zfice(i))-zoliqp(i),0.0) &
@@ -1043,6 +1252,11 @@
               zifl(i) = zifl(i)+zrfl(i)
               zrfl(i) = 0.
+           if (fl_cor_ebil .GT. 0) then
+              zt(i)=zt(i)+zsolid*(RG*dtime)/(paprs(i,k)-paprs(i,k+1)) &
+                      *(RLSTT-RLVTT)/RCPD/(1.0+RVTMP2*(zq(i)+zmqc(i)))
+           else
               zt(i)=zt(i)+zsolid*(RG*dtime)/(paprs(i,k)-paprs(i,k+1)) &
                       *(RLSTT-RLVTT)/RCPD/(1.0+RVTMP2*zq(i))
+           end if
            ENDIF  ! (iflag_bergeron .EQ. 1) .AND. (zt(i) .LT. 273.15)
 !RC   
@@ -1094,5 +1308,4 @@
      ! Fin de formation des precipitations
      ! ----------------------------------------------------------------
-     !
      !
      ! Calculer les tendances de q et de t:
@@ -1202,7 +1415,7 @@
      DO i = 1, klon
         zcpair=RCPD*(1.0+RVTMP2*(q(i,k)+d_q(i,k)))
-        zmair=(paprs(i,k)-paprs(i,k+1))/RG
+        zmair(i)=(paprs(i,k)-paprs(i,k+1))/RG
         zm_solid = (prfl(i,k)-prfl(i,k+1)+psfl(i,k)-psfl(i,k+1))*dtime
-        d_t(i,k) = d_t(i,k) + zlh_solid(i) *zm_solid / (zcpair*zmair)
+        d_t(i,k) = d_t(i,k) + zlh_solid(i) *zm_solid / (zcpair*zmair(i))
      END DO
   END DO
Index: LMDZ5/branches/testing/libf/phylmd/iophys.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/iophys.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/iophys.F90	(revision 2839)
@@ -1,2 +1,7 @@
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Interface pour ecrire en netcdf avec les routines d'enseignement
+! iotd de Frederic Hourdin
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
       subroutine iophys_ecrit(nom,lllm,titre,unite,px)
 
@@ -62,4 +67,45 @@
       end
 
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Version avec reindexation pour appeler depuis les routines internes
+! à la sous surface
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+
+    subroutine iophys_ecrit_index(nom,lllm,titre,unite,knon,knindex,px)
+
+    USE mod_phys_lmdz_para, ONLY: klon_omp
+    USE dimphy, ONLY : klon
+    USE mod_grid_phy_lmdz, ONLY: klon_glo
+    IMPLICIT NONE
+
+! This subroutine returns the sea surface temperature already read from limit.nc
+!
+
+! Arguments on input:
+    INTEGER lllm
+    CHARACTER (len=*) :: nom,titre,unite
+    REAL px(klon_omp,lllm)
+    INTEGER, INTENT(IN)                  :: knon     ! nomber of points on compressed grid
+    INTEGER, DIMENSION(klon), INTENT(IN) :: knindex  ! grid point number for compressed grid
+    REAL, DIMENSION(klon,lllm) :: varout
+
+    INTEGER :: i,l
+
+    IF (klon/=klon_omp) THEN
+      print*,'klon, klon_omp',klon,klon_omp
+      STOP'probleme de dimension parallele'
+    ENDIF
+
+    varout(1:klon,1:lllm)=0.
+    DO l = 1, lllm
+    DO i = 1, knon
+       varout(knindex(i),l) = px(i,l)
+    END DO
+    END DO
+    CALL iophys_ecrit(nom,lllm,titre,unite,varout)
+
+  END SUBROUTINE iophys_ecrit_index
+
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       SUBROUTINE iophys_ini
@@ -68,4 +114,5 @@
       USE regular_lonlat_mod, ONLY: lon_reg, lat_reg
       USE dimphy, ONLY: klev
+      USE mod_grid_phy_lmdz, ONLY: klon_glo
 
       IMPLICIT NONE
@@ -88,4 +135,5 @@
 
 real pi
+INTEGER nlat_eff
 
 !   Arguments:
@@ -94,8 +142,16 @@
 !$OMP MASTER
     IF (is_mpi_root) THEN       
+
+! Bidouille pour gerer le fait que lat_reg contient deux latitudes
+! en version uni-dimensionnelle (chose qui pourrait être résolue
+! par ailleurs)
+IF (klon_glo==1) THEN
+   nlat_eff=1
+ELSE
+   nlat_eff=size(lat_reg)
+ENDIF
 pi=2.*asin(1.)
 call iotd_ini('phys.nc   ', &
-!iim,jjp1,llm,rlonv(1:iim)*180./pi,rlatu*180./pi,presnivs)
-size(lon_reg),size(lat_reg),klev,lon_reg(:)*180./pi,lat_reg*180./pi,presnivs)
+size(lon_reg),nlat_eff,klev,lon_reg(:)*180./pi,lat_reg*180./pi,presnivs)
     ENDIF
 !$OMP END MASTER
Index: LMDZ5/branches/testing/libf/phylmd/limit_read_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/limit_read_mod.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/limit_read_mod.F90	(revision 2839)
@@ -223,5 +223,5 @@
           ierr=NF90_INQUIRE(nid, UnlimitedDimID=ndimid)
           ierr=NF90_INQUIRE_DIMENSION(nid, ndimid, len=nn)
-          WRITE(abort_message,'(a,2(i0,a))')'limit.nc records number (',nn,') does no'//&
+          WRITE(abort_message,'(a,2(i3,a))')'limit.nc records number (',nn,') does no'//&
             't match year length (',year_len,')'
           IF(nn/=year_len) CALL abort_physic(modname,abort_message,1)
Index: LMDZ5/branches/testing/libf/phylmd/open_climoz_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/open_climoz_m.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/open_climoz_m.F90	(revision 2839)
@@ -1,73 +1,101 @@
 ! $Id$
-module open_climoz_m
+MODULE open_climoz_m
 
-  implicit none
+  USE print_control_mod, ONLY: lunout
+  IMPLICIT NONE
 
-contains
+CONTAINS
 
-  subroutine open_climoz(ncid, press_in_edg)
+!-------------------------------------------------------------------------------
+!
+SUBROUTINE open_climoz(ncid, press_in_cen, press_in_edg, time_in, daily, adjust)
+!
+!-------------------------------------------------------------------------------
+  USE netcdf95, ONLY: nf95_open, nf95_close, nf95_gw_var, nf95_inq_varid
+  USE netcdf,   ONLY: nf90_nowrite
+  USE mod_phys_lmdz_mpi_data,      ONLY: is_mpi_root
+  USE mod_phys_lmdz_mpi_transfert, ONLY: bcast_mpi
+  USE phys_cal_mod,                ONLY: calend, year_len, year_cur
+!-------------------------------------------------------------------------------
+! Purpose: This procedure should be called once per "gcm" run, by a single
+!          thread of each MPI process.
+!          The root MPI process opens "climoz_LMDZ.nc", reads the pressure
+! levels and the times and broadcasts them to the other processes.
+!          We assume that, in "climoz_LMDZ.nc", the pressure levels are in hPa
+! and in strictly ascending order.
+!-------------------------------------------------------------------------------
+! Arguments (OpenMP shared):
+  INTEGER, INTENT(OUT):: ncid      !--- "climoz_LMDZ.nc" identifier
+  REAL, POINTER :: press_in_cen(:) !--- at cells centers
+  REAL, POINTER :: press_in_edg(:) !--- at the interfaces (pressure intervals)
+  REAL, POINTER :: time_in(:)      !--- records times, in days since Jan. 1st
+  LOGICAL, INTENT(IN) :: daily     !--- daily files (calendar dependent days nb)
+  LOGICAL, INTENT(IN) :: adjust    !--- tropopause adjustement required
+!   pressure levels press_in_cen/edg are in Pa a,d strictly ascending order.
+!   time_in is only used for monthly files (14 records)
+!-------------------------------------------------------------------------------
+! Local variables:
+  INTEGER :: varid                 !--- NetCDF variables identifier
+  INTEGER :: nlev, ntim            !--- pressure levels and time records numbers
+  CHARACTER(LEN=80)  :: sub
+  CHARACTER(LEN=320) :: msg
+!-------------------------------------------------------------------------------
+  sub="open_climoz"
+  WRITE(lunout,*)"Entering routine "//TRIM(sub)
 
-    ! This procedure should be called once per "gcm" run, by a single
-    ! thread of each MPI process.
-    ! The root MPI process opens "climoz_LMDZ.nc", reads the pressure
-    ! levels and broadcasts them to the other processes.
+  IF(is_mpi_root) THEN
 
-    ! We assume that, in "climoz_LMDZ.nc", the pressure levels are in hPa
-    ! and in strictly ascending order.
+    !--- OPEN FILE, READ PRESSURE LEVELS AND TIME VECTOR
+    CALL nf95_open("climoz_LMDZ.nc", nf90_nowrite, ncid)
+    CALL nf95_inq_varid(ncid, "plev", varid)
+    CALL nf95_gw_var(ncid, varid, press_in_cen)
+    ! Convert from hPa to Pa because "paprs" and "pplay" are in Pa:
+    press_in_cen = press_in_cen * 100.
+    nlev = SIZE(press_in_cen)
+    CALL NF95_INQ_VARID(ncID, "time", varID)
+    CALL NF95_GW_VAR(ncid, varid, time_in)
+    ntim = SIZE(time_in)
 
-    use netcdf95, only: nf95_open, nf95_close, nf95_gw_var, nf95_inq_varid
-    use netcdf, only: nf90_nowrite
+    !--- BUILD EDGES OF PRESSURE INTERVALS: HALFWAY IN LOGARITHMS
+    ALLOCATE(press_in_edg(nlev+1))
+    press_in_edg=[0.,SQRT(press_in_cen(1:nlev-1)*press_in_cen(2:nlev)),HUGE(0.)]
 
-    use mod_phys_lmdz_mpi_data, only: is_mpi_root
-    use mod_phys_lmdz_mpi_transfert, only: bcast_mpi ! broadcast
+    !--- CHECK RECORDS NUMBER AND DISPLAY CORRESPONDING INFORMATION
+    IF(daily.AND.ntim/=year_len) THEN
+      WRITE(msg,'(a,3(i4,a))')TRIM(sub)//': Expecting a daily ozone file with',&
+     &year_len,' records (year ',year_cur,') ; found ',ntim,' instead'
+      CALL abort_physic(sub, msg, 1)
+    ELSE IF(ALL([360,14]/=ntim)) THEN
+      WRITE(msg,'(a,i4,a)')TRIM(sub)//': Expecting an ozone file with 14 (mont'&
+     &//'hly case) or 360 (old style files) records ; found ',ntim,' instead'
+      CALL abort_physic(sub, msg, 1)
+    ELSE
+      IF(daily) THEN
+         WRITE(msg,'(a,2(i4,a))')'daily file (',ntim,' days in ',year_cur,')'
+       ELSE IF(ntim==14) THEN
+         msg='14 records monthly file'
+       ELSE
+         msg='360 records files (old convention)'
+       END IF
+      WRITE(lunout,*)TRIM(sub)//': Using a '//TRIM(msg)
+    END IF
 
-    integer, intent(out):: ncid ! of "climoz_LMDZ.nc", OpenMP shared
+    !--- MESSAGE ABOUT OPTIONAL STRETCHING FOR TROPOPAUSES MATCHING
+    IF(adjust) THEN
+      WRITE(lunout,*)TRIM(sub)//': Adjusting O3 field to match gcm tropopause.'
+    ELSE
+      WRITE(lunout,*)TRIM(sub)//': Interpolating O3 field directly on gcm levels.'
+    END IF
 
-    real, pointer:: press_in_edg(:)
-    ! edges of pressure intervals for ozone climatology, in Pa, in strictly
-    ! ascending order, OpenMP shared
+  END IF
+  CALL bcast_mpi(nlev)
+  IF(.NOT.is_mpi_root) ALLOCATE(press_in_cen(nlev  )); CALL bcast_mpi(press_in_cen)
+  IF(.NOT.is_mpi_root) ALLOCATE(press_in_edg(nlev+1)); CALL bcast_mpi(press_in_edg)
+  CALL bcast_mpi(ntim)
+  IF(.NOT.is_mpi_root) ALLOCATE(time_in(ntim));        CALL bcast_mpi(time_in)
 
-    ! Variables local to the procedure:
+END SUBROUTINE open_climoz
+!
+!-------------------------------------------------------------------------------
 
-    real, pointer:: plev(:)
-    ! (pressure levels for ozone climatology, converted to Pa, in strictly
-    ! ascending order)
-
-    integer varid ! for NetCDF
-    integer n_plev ! number of pressure levels in the input data
-    integer k
-
-    !---------------------------------------
-
-    print *, "Call sequence information: open_climoz"
-
-    if (is_mpi_root) then
-       call nf95_open("climoz_LMDZ.nc", nf90_nowrite, ncid)
-
-       call nf95_inq_varid(ncid, "plev", varid)
-       call nf95_gw_var(ncid, varid, plev)
-       ! Convert from hPa to Pa because "paprs" and "pplay" are in Pa:
-       plev = plev * 100.
-       n_plev = size(plev)
-    end if
-
-    call bcast_mpi(n_plev)
-    if (.not. is_mpi_root) allocate(plev(n_plev))
-    call bcast_mpi(plev)
-    
-    ! Compute edges of pressure intervals:
-    allocate(press_in_edg(n_plev + 1))
-    if (is_mpi_root) then
-       press_in_edg(1) = 0.
-       ! We choose edges halfway in logarithm:
-       forall (k = 2:n_plev) press_in_edg(k) = sqrt(plev(k - 1) * plev(k))
-       press_in_edg(n_plev + 1) = huge(0.)
-       ! (infinity, but any value guaranteed to be greater than the
-       ! surface pressure would do)
-    end if
-    call bcast_mpi(press_in_edg)
-    deallocate(plev) ! pointer
-
-  end subroutine open_climoz
-
-end module open_climoz_m
+END MODULE open_climoz_m
Index: LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90	(revision 2839)
@@ -339,4 +339,5 @@
     PRINT *, 'iniaqua: before phyredem'
 
+    pbl_tke(:,:,:)=1.e-8
     falb1 = albedo
     falb2 = albedo
@@ -354,4 +355,8 @@
     entr_therm = 0.
     detr_therm = 0.
+    ale_bl = 0.
+    ale_bl_trig =0. 
+    alp_bl =0.
+
 
 
Index: LMDZ5/branches/testing/libf/phylmd/phys_cal_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_cal_mod.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/phys_cal_mod.F90	(revision 2839)
@@ -9,5 +9,5 @@
   INTEGER,SAVE :: day_cur       ! current day
 !$OMP THREADPRIVATE(day_cur)
-  INTEGER,SAVE :: days_elapsed  ! number of whole days since start of the simulation 
+  INTEGER,SAVE :: days_elapsed  ! number of whole days since start of the current year
 !$OMP THREADPRIVATE(days_elapsed)
   INTEGER,SAVE :: mth_len       ! number of days in the current month
@@ -33,11 +33,12 @@
 !$OMP THREADPRIVATE(calend)
 
-
 CONTAINS
   
   SUBROUTINE phys_cal_init(annee_ref,day_ref)
-  USE IOIPSL, ONLY:  ymds2ju
-  USE ioipsl_getin_p_mod, ONLY: getin_p
-  IMPLICIT NONE
+
+    USE IOIPSL, ONLY:  ymds2ju
+    USE ioipsl_getin_p_mod, ONLY: getin_p
+
+    IMPLICIT NONE
     INTEGER,INTENT(IN) :: annee_ref
     INTEGER,INTENT(IN) :: day_ref
@@ -79,3 +80,2 @@
 
 END MODULE phys_cal_mod
-
Index: LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2839)
@@ -163,4 +163,6 @@
       REAL, SAVE, ALLOCATABLE :: lcc3dstra(:,:)
       !$OMP THREADPRIVATE(lcc3dstra)
+      REAL, SAVE, ALLOCATABLE :: od443aer(:) 
+      !$OMP THREADPRIVATE(od443aer) 
       REAL, SAVE, ALLOCATABLE :: od550aer(:) 
       !$OMP THREADPRIVATE(od550aer) 
@@ -207,4 +209,6 @@
       REAL, SAVE, ALLOCATABLE :: loaddust(:) 
       !$OMP THREADPRIVATE(loaddust) 
+      REAL, SAVE, ALLOCATABLE :: loadno3(:) 
+      !$OMP THREADPRIVATE(loadno3) 
       REAL, SAVE, ALLOCATABLE :: load_tmp1(:) 
       !$OMP THREADPRIVATE(load_tmp1) 
@@ -213,12 +217,4 @@
       REAL, SAVE, ALLOCATABLE :: load_tmp3(:) 
       !$OMP THREADPRIVATE(load_tmp3) 
-      REAL, SAVE, ALLOCATABLE :: load_tmp4(:) 
-      !$OMP THREADPRIVATE(load_tmp4) 
-      REAL, SAVE, ALLOCATABLE :: load_tmp5(:) 
-      !$OMP THREADPRIVATE(load_tmp5) 
-      REAL, SAVE, ALLOCATABLE :: load_tmp6(:) 
-      !$OMP THREADPRIVATE(load_tmp6) 
-      REAL, SAVE, ALLOCATABLE :: load_tmp7(:) 
-      !$OMP THREADPRIVATE(load_tmp7) 
 
 !IM ajout variables CFMIP2/CMIP5
@@ -352,6 +348,6 @@
 !>jyg+nrlmd
   !
-      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: wbeff, zmax_th, zq2m, zt2m
-!$OMP THREADPRIVATE(wbeff, zmax_th, zq2m, zt2m)
+      REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: wbeff, convoccur, zmax_th, zq2m, zt2m
+!$OMP THREADPRIVATE(wbeff, convoccur, zmax_th, zq2m, zt2m)
       REAL,ALLOCATABLE,SAVE,DIMENSION(:) :: zt2m_min_mon, zt2m_max_mon
 !$OMP THREADPRIVATE(zt2m_min_mon, zt2m_max_mon)
@@ -487,4 +483,6 @@
 !$OMP THREADPRIVATE(budg_sed_part)
 #endif
+      REAL, ALLOCATABLE, SAVE, DIMENSION(:) :: pr_tropopause
+!$OMP THREADPRIVATE(pr_tropopause)
 
 CONTAINS
@@ -578,4 +576,5 @@
       allocate(lcc3dcon(klon, klev))
       allocate(lcc3dstra(klon, klev))
+      allocate(od443aer(klon))
       allocate(od550aer(klon))
       allocate(od865aer(klon))
@@ -600,11 +599,8 @@
       allocate(loadss(klon))
       allocate(loaddust(klon))
+      allocate(loadno3(klon))
       allocate(load_tmp1(klon))
       allocate(load_tmp2(klon))
       allocate(load_tmp3(klon))
-      allocate(load_tmp4(klon))
-      allocate(load_tmp5(klon))
-      allocate(load_tmp6(klon))
-      allocate(load_tmp7(klon))
 
 !IM ajout variables CFMIP2/CMIP5
@@ -628,4 +624,5 @@
 !!          Wake variables
       ALLOCATE(ale_wake(klon), alp_wake(klon))
+      ale_wake(:)=0.
       ALLOCATE(wake_h(klon),wake_k(klon))
       ALLOCATE(wake_omg(klon, klev))
@@ -677,5 +674,5 @@
       ALLOCATE(kh(klon), kh_x(klon), kh_w(klon))
 !
-      ALLOCATE(wbeff(klon), zmax_th(klon))
+      ALLOCATE(wbeff(klon), convoccur(klon), zmax_th(klon))
       ALLOCATE(zq2m(klon), zt2m(klon), weak_inversion(klon))
       ALLOCATE(zt2m_min_mon(klon), zt2m_max_mon(klon))
@@ -764,4 +761,5 @@
       ALLOCATE (vsed_aer(klon,klev))
 #endif
+      ALLOCATE (pr_tropopause(klon))
 
 END SUBROUTINE phys_local_var_init
@@ -837,4 +835,5 @@
       deallocate(lcc3dcon)
       deallocate(lcc3dstra)
+      deallocate(od443aer)
       deallocate(od550aer)
       deallocate(od865aer)
@@ -859,11 +858,8 @@
       deallocate(loadss) 
       deallocate(loaddust) 
+      deallocate(loadno3) 
       deallocate(load_tmp1)
       deallocate(load_tmp2)
       deallocate(load_tmp3)
-      deallocate(load_tmp4)
-      deallocate(load_tmp5)
-      deallocate(load_tmp6)
-      deallocate(load_tmp7)
       deallocate(du_gwd_hines,dv_gwd_hines,d_t_hin)
       deallocate(d_q_ch4)
@@ -935,5 +931,5 @@
       DEALLOCATE(kh, kh_x, kh_w)
 !
-      DEALLOCATE(wbeff, zmax_th)
+      DEALLOCATE(wbeff, convoccur, zmax_th)
       DEALLOCATE(zq2m, zt2m, weak_inversion)
       DEALLOCATE(zt2m_min_mon, zt2m_max_mon)
@@ -1018,4 +1014,5 @@
       DEALLOCATE (budg_sed_part)
 #endif
+      DEALLOCATE (pr_tropopause)
 
 END SUBROUTINE phys_local_var_end
Index: LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2839)
@@ -669,4 +669,6 @@
   TYPE(ctrl_out), SAVE :: o_wbeff = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'wbeff', 'Conv. updraft velocity at LFC (<100)', 'm/s', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_convoccur = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'convoccur', 'Convective occurence', '', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_prw = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'prw', 'Precipitable water', 'kg/m2', (/ ('', i=1, 10) /))
@@ -1092,4 +1094,6 @@
     'OD_10um_STRAT', 'Stratospheric Aerosol Optical depth at 10 um ', '1', (/ ('', i=1, 10) /))
 !
+  TYPE(ctrl_out), SAVE :: o_od443aer = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'od443aer', 'Total aerosol optical depth at 440nm', '-', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_od550aer = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'od550aer', 'Total aerosol optical depth at 550nm', '-', (/ ('', i=1, 10) /))
@@ -1134,4 +1138,6 @@
   TYPE(ctrl_out), SAVE :: o_loaddust = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'loaddust', 'Column Load of Dust ', 'kg/m2', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_loadno3 = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'loadno3', 'Column Load of Nitrate ', 'kg/m2', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_swtoaas_nat = ctrl_out((/ 4, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'swtoaas_nat', 'Natural aerosol radiative forcing all-sky at TOA', 'W/m2', (/ ('', i=1, 10) /))
Index: LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_mod.F90	(revision 2839)
@@ -5,5 +5,4 @@
   USE indice_sol_mod
   USE phys_output_var_mod
-  USE aero_mod, only : naero_spc,name_aero
   USE phys_output_write_mod, ONLY : phys_output_write
   REAL, DIMENSION(nfiles),SAVE :: ecrit_files
@@ -40,5 +39,4 @@
     USE phys_cal_mod, only : hour, calend
     USE mod_phys_lmdz_para
-    USE aero_mod, only : naero_spc,name_aero
     !Martin
     USE surface_data, ONLY : ok_snow
@@ -46,5 +44,5 @@
     USE mod_grid_phy_lmdz, only: klon_glo,nbp_lon,nbp_lat
     USE print_control_mod, ONLY: prt_level,lunout
-    USE vertical_layers_mod, ONLY: ap,bp,preff,presnivs
+    USE vertical_layers_mod, ONLY: ap,bp,preff,presnivs, aps, bps, pseudoalt
     USE time_phylmdz_mod, ONLY: day_ini, itau_phy, start_time, annee_ref, day_ref
 #ifdef CPP_XIOS
@@ -95,5 +93,4 @@
     INTEGER                               :: idayref
     REAL                                  :: zjulian_start, zjulian
-    REAL, DIMENSION(klev)                 :: Ahyb, Bhyb, Alt
     CHARACTER(LEN=4), DIMENSION(nlevSTD)  :: clevSTD
     REAL, DIMENSION(nlevSTD)              :: rlevSTD
@@ -293,15 +290,4 @@
     zdtime_moy = dtime         ! Frequence ou l on moyenne
 
-    ! Calcul des Ahyb, Bhyb et Alt
-    DO k=1,klev
-       Ahyb(k)=(ap(k)+ap(k+1))/2.
-       Bhyb(k)=(bp(k)+bp(k+1))/2.
-       Alt(k)=log(preff/presnivs(k))*8.
-    ENDDO
-    !          if(prt_level.ge.1) then
-    WRITE(lunout,*)'Ap Hybrid = ',Ahyb(1:klev)
-    WRITE(lunout,*)'Bp Hybrid = ',Bhyb(1:klev)
-    WRITE(lunout,*)'Alt approx des couches pour une haut d echelle de 8km = ',Alt(1:klev)
-    !          ENDIF
 
   ecrit_files(7) = ecrit_files(1)
@@ -345,9 +331,9 @@
             levmax(iff) - levmin(iff) + 1, presnivs(levmin(iff):levmax(iff)))
     CALL wxios_add_vaxis("Ahyb", &
-            levmax(iff) - levmin(iff) + 1, Ahyb)
+            levmax(iff) - levmin(iff) + 1, aps)
     CALL wxios_add_vaxis("Bhyb", &
-            levmax(iff) - levmin(iff) + 1, Bhyb)
+            levmax(iff) - levmin(iff) + 1, bps)
     CALL wxios_add_vaxis("Alt", &
-            levmax(iff) - levmin(iff) + 1, Alt)
+            levmax(iff) - levmin(iff) + 1, pseudoalt)
    ELSE
     ! NMC files
@@ -418,11 +404,11 @@
 !!!! Composantes de la coordonnee sigma-hybride 
           CALL histvert(nid_files(iff), "Ahyb","Ahyb comp of Hyb Cord ", "Pa", &
-               levmax(iff) - levmin(iff) + 1,Ahyb,nvertap(iff))
+               levmax(iff) - levmin(iff) + 1,aps,nvertap(iff))
 
           CALL histvert(nid_files(iff), "Bhyb","Bhyb comp of Hyb Cord", " ", &
-               levmax(iff) - levmin(iff) + 1,Bhyb,nvertbp(iff))
+               levmax(iff) - levmin(iff) + 1,bps,nvertbp(iff))
 
           CALL histvert(nid_files(iff), "Alt","Height approx for scale heigh of 8km at levels", "Km", &                       
-               levmax(iff) - levmin(iff) + 1,Alt,nvertAlt(iff))
+               levmax(iff) - levmin(iff) + 1,pseudoalt,nvertAlt(iff))
 
           ELSE
Index: LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/phys_output_var_mod.F90	(revision 2839)
@@ -24,4 +24,17 @@
   REAL, SAVE, ALLOCATABLE :: bils_latent(:) ! bilan de chaleur au sol
   !$OMP THREADPRIVATE(bils_ec,bils_ech,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
+  ! output variables for energy conservation tests, computed in add_phys_tend
+  REAL, SAVE, ALLOCATABLE :: d_qw_col(:)      ! watter vapour mass budget for each column (kg/m2/s)
+  REAL, SAVE, ALLOCATABLE :: d_ql_col(:)      ! liquid watter mass budget for each column (kg/m2/s)
+  REAL, SAVE, ALLOCATABLE :: d_qs_col(:)      ! solid watter mass budget for each column (kg/m2/s)
+  REAL, SAVE, ALLOCATABLE :: d_qt_col(:)      ! total watter mass budget for each column (kg/m2/s)
+  REAL, SAVE, ALLOCATABLE :: d_ek_col(:)      ! kinetic energy budget for each column (W/m2)
+  REAL, SAVE, ALLOCATABLE :: d_h_dair_col(:)  ! enthalpy budget of dry air for each column (W/m2)
+  REAL, SAVE, ALLOCATABLE :: d_h_qw_col(:)    ! enthalpy budget of watter vapour for each column (W/m2)
+  REAL, SAVE, ALLOCATABLE :: d_h_ql_col(:)    ! enthalpy budget of liquid watter for each column (W/m2)
+  REAL, SAVE, ALLOCATABLE :: d_h_qs_col(:)    ! enthalpy budget of solid watter  for each column (W/m2)
+  REAL, SAVE, ALLOCATABLE :: d_h_col(:)       ! total enthalpy budget for each column (W/m2)
+  !$OMP THREADPRIVATE(d_qw_col, d_ql_col, d_qs_col, d_qt_col, d_ek_col, d_h_dair_col)
+  !$OMP THREADPRIVATE(d_h_qw_col, d_h_ql_col, d_h_qs_col, d_h_col)
 
 ! Marine
@@ -121,4 +134,8 @@
 
     allocate (bils_ec(klon),bils_ech(klon),bils_tke(klon),bils_diss(klon),bils_kinetic(klon),bils_enthalp(klon),bils_latent(klon))
+    allocate (d_qw_col(klon), d_ql_col(klon), d_qs_col(klon), d_qt_col(klon), d_ek_col(klon), d_h_dair_col(klon) &
+  &         , d_h_qw_col(klon), d_h_ql_col(klon), d_h_qs_col(klon), d_h_col(klon))
+    d_qw_col=0. ; d_ql_col=0. ; d_qs_col=0. ; d_qt_col=0. ; d_ek_col=0. ; d_h_dair_col =0.
+    d_h_qw_col=0. ; d_h_ql_col=0. ; d_h_qs_col=0. ; d_h_col=0.
 
 ! Marine
@@ -155,4 +172,6 @@
     deallocate(snow_o,zfra_o,itau_con)
     deallocate (bils_ec,bils_ech,bils_tke,bils_diss,bils_kinetic,bils_enthalp,bils_latent)
+    deallocate (d_qw_col, d_ql_col, d_qs_col, d_qt_col, d_ek_col, d_h_dair_col &
+  &           , d_h_qw_col, d_h_ql_col, d_h_qs_col, d_h_col)
 
 ! Marine
